diff --git a/pki/base/silent/src/com/netscape/pkisilent/ConfigureTPS.java b/pki/base/silent/src/com/netscape/pkisilent/ConfigureTPS.java
index d4df34a39158661fd1b1f3a8794878e6ed286263..366fb57b69639c3d66fc1a91d01573266a9802f7 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/ConfigureTPS.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/ConfigureTPS.java
@@ -19,6 +19,7 @@ package com.netscape.pkisilent;
 // --- END COPYRIGHT BLOCK ---
 
 import java.io.ByteArrayInputStream;
+import java.io.UnsupportedEncodingException;
 import java.net.URLEncoder;
 
 import com.netscape.pkisilent.argparser.ArgParser;
@@ -193,8 +194,7 @@ public class ConfigureTPS {
         return st;
     }
 
-    public boolean DomainPanel() {
-        boolean st = false;
+    public boolean DomainPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -204,7 +204,7 @@ public class ConfigureTPS {
         String query_string = "p=3" +
                             "&choice=existingdomain" +
                             "&sdomainURL=" +
-                            URLEncoder.encode(domain_url) +
+                            URLEncoder.encode(domain_url, "UTF-8") +
                             "&op=next" +
                             "&xml=true";
 
@@ -227,18 +227,18 @@ public class ConfigureTPS {
 
     }
 
-    public boolean SecurityDomainLoginPanel() {
+    public boolean SecurityDomainLoginPanel() throws UnsupportedEncodingException {
         String tps_url = "https://" + cs_hostname + ":" + cs_port +
                             "/tps/admin/console/config/wizard" +
                             "?p=3&subsystem=TPS";
 
-        String query_string = "url=" + URLEncoder.encode(tps_url) + "";
+        String query_string = "url=" + URLEncoder.encode(tps_url, "UTF-8") + "";
 
         HTTPResponse hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_login_uri, query_string);
 
         String query_string_1 = "uid=" + sd_admin_name +
-                                "&pwd=" + URLEncoder.encode(sd_admin_password) +
-                                "&url=" + URLEncoder.encode(tps_url) +
+                                "&pwd=" + URLEncoder.encode(sd_admin_password, "UTF-8") +
+                                "&url=" + URLEncoder.encode(tps_url, "UTF-8") +
                                 "";
 
         hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_get_cookie_uri,
@@ -269,8 +269,7 @@ public class ConfigureTPS {
 
     }
 
-    public boolean SubsystemPanel() {
-        boolean st = false;
+    public boolean SubsystemPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -279,7 +278,7 @@ public class ConfigureTPS {
         String query_string = "p=5" +
                         "&choice=newsubsystem" +
                         "&subsystemName=" +
-                        URLEncoder.encode(subsystem_name) +
+                        URLEncoder.encode(subsystem_name, "UTF-8") +
                         "&op=next" +
                         "&xml=true";
 
@@ -304,8 +303,6 @@ public class ConfigureTPS {
         px.prettyprintxml();
 
         sleep_time();
-        // TKS choice panel
-        String tks_url = "https://" + tks_hostname + ":" + tks_ssl_port;
         query_string = "p=7" +
                         "&urls=0" +
                         "&op=next" +
@@ -339,20 +336,18 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean LdapAuthConnectionPanel() {
-        // auth db 
-        boolean st = false;
+    public boolean LdapAuthConnectionPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=9" +
                         "&host=" +
-                        URLEncoder.encode(ldap_auth_host) +
+                        URLEncoder.encode(ldap_auth_host, "UTF-8") +
                         "&port=" +
-                        URLEncoder.encode(ldap_auth_port) +
+                        URLEncoder.encode(ldap_auth_port, "UTF-8") +
                         "&basedn=" +
-                        URLEncoder.encode(ldap_auth_base_dn) +
+                        URLEncoder.encode(ldap_auth_base_dn, "UTF-8") +
                         "&op=next" +
                         "&xml=true";
 
@@ -366,27 +361,25 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean LdapConnectionPanel() {
-        boolean st = false;
+    public boolean LdapConnectionPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=10" +
                         "&host=" +
-                        URLEncoder.encode(ldap_host) +
+                        URLEncoder.encode(ldap_host, "UTF-8") +
                         "&port=" +
-                        URLEncoder.encode(ldap_port) +
+                        URLEncoder.encode(ldap_port, "UTF-8") +
                         "&binddn=" +
-                        URLEncoder.encode(bind_dn) +
+                        URLEncoder.encode(bind_dn, "UTF-8") +
                         "&__bindpwd=" +
-                        URLEncoder.encode(bind_password) +
+                        URLEncoder.encode(bind_password, "UTF-8") +
                         "&basedn=" +
-                        URLEncoder.encode(base_dn) +
+                        URLEncoder.encode(base_dn, "UTF-8") +
                         "&database=" +
-                        URLEncoder.encode(db_name) +
+                        URLEncoder.encode(db_name, "UTF-8") +
                         "&display=" +
-                        URLEncoder.encode("") +
                         "&op=next" +
                         "&xml=true";
 
@@ -400,8 +393,7 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean TokenChoicePanel() {
-        boolean st = false;
+    public boolean TokenChoicePanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -413,7 +405,7 @@ public class ConfigureTPS {
         if (token_name.equalsIgnoreCase("internal")) {
             query_string = "p=1" +
                             "&choice=" +
-                            URLEncoder.encode("NSS Certificate DB") +
+                            URLEncoder.encode("NSS Certificate DB", "UTF-8") +
                             "&op=next" +
                             "&xml=true";
 
@@ -428,9 +420,9 @@ public class ConfigureTPS {
             // login to hsm first
             query_string = "p=2" +
                             "&uTokName=" +
-                            URLEncoder.encode(token_name) +
+                            URLEncoder.encode(token_name, "UTF-8") +
                             "&__uPasswd=" +
-                            URLEncoder.encode(token_pwd) +
+                            URLEncoder.encode(token_pwd, "UTF-8") +
                             "&op=next" +
                             "&xml=true";
 
@@ -443,7 +435,7 @@ public class ConfigureTPS {
             // choice with token name now
             query_string = "p=1" +
                             "&choice=" +
-                            URLEncoder.encode(token_name) +
+                            URLEncoder.encode(token_name, "UTF-8") +
                             "&op=next" +
                             "&xml=true";
 
@@ -489,24 +481,24 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean CertSubjectPanel() {
+    public boolean CertSubjectPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
 
         String query_string = "p=12" +
                     "&sslserver=" +
-                    URLEncoder.encode(tps_server_cert_subject_name) +
+                    URLEncoder.encode(tps_server_cert_subject_name, "UTF-8") +
                     "&sslserver_nick=" +
-                    URLEncoder.encode(tps_server_cert_nickname) +
+                    URLEncoder.encode(tps_server_cert_nickname, "UTF-8") +
                     "&subsystem=" +
-                    URLEncoder.encode(tps_subsystem_cert_subject_name) +
+                    URLEncoder.encode(tps_subsystem_cert_subject_name, "UTF-8") +
                     "&subsystem_nick=" +
-                    URLEncoder.encode(tps_subsystem_cert_nickname) +
+                    URLEncoder.encode(tps_subsystem_cert_nickname, "UTF-8") +
                     "&audit_signing=" +
-                    URLEncoder.encode(tps_audit_signing_cert_subject_name) +
+                    URLEncoder.encode(tps_audit_signing_cert_subject_name, "UTF-8") +
                     "&audit_signing_nick=" +
-                    URLEncoder.encode(tps_audit_signing_cert_nickname) +
+                    URLEncoder.encode(tps_audit_signing_cert_nickname, "UTF-8") +
                     "&urls=0" +
                     "&op=next" +
                     "&xml=true";
@@ -548,8 +540,7 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean AdminCertReqPanel() {
-        boolean st = false;
+    public boolean AdminCertReqPanel() throws UnsupportedEncodingException {
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
         ParseXML px = new ParseXML();
@@ -580,13 +571,13 @@ public class ConfigureTPS {
         String query_string = "p=14" +
                             "&uid=" + admin_user +
                             "&name=" +
-                            URLEncoder.encode("TPS Administrator") +
+                            URLEncoder.encode("TPS Administrator", "UTF-8") +
                             "&email=" +
-                            URLEncoder.encode(admin_email) +
-                            "&__pwd=" + URLEncoder.encode(admin_password) +
-                            "&__admin_password_again=" + URLEncoder.encode(admin_password) +
+                            URLEncoder.encode(admin_email, "UTF-8") +
+                            "&__pwd=" + URLEncoder.encode(admin_password, "UTF-8") +
+                            "&__admin_password_again=" + URLEncoder.encode(admin_password, "UTF-8") +
                             "&cert_request=" +
-                            URLEncoder.encode(admin_cert_request) +
+                            URLEncoder.encode(admin_cert_request, "UTF-8") +
                             "&display=0" +
                             "&profileId=" + "caAdminCert" +
                             "&cert_request_type=" + "crmf" +
@@ -594,11 +585,11 @@ public class ConfigureTPS {
                             "&uid=" + admin_user +
                             "&clone=0" +
                             "&securitydomain=" +
-                            URLEncoder.encode(domain_name) +
+                            URLEncoder.encode(domain_name, "UTF-8") +
                             "&subject=" +
-                            URLEncoder.encode(agent_cert_subject) +
+                            URLEncoder.encode(agent_cert_subject, "UTF-8") +
                             "&requestor_name=" +
-                            URLEncoder.encode(requestor_name) +
+                            URLEncoder.encode(requestor_name, "UTF-8") +
                             "&sessionID=" + tps_session_id +
                             "&auth_hostname=" + ca_hostname +
                             "&auth_port=" + ca_ssl_port +
@@ -617,7 +608,7 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean AdminCertImportPanel() {
+    public boolean AdminCertImportPanel() throws UnsupportedEncodingException {
         boolean st = false;
         HTTPResponse hr = null;
         ByteArrayInputStream bais = null;
@@ -670,7 +661,7 @@ public class ConfigureTPS {
         String query_string_1 = "p=15" +
                             "&serialNumber=" + admin_serial_number +
                             "&caHost=" +
-                            URLEncoder.encode(ca_hostname) +
+                            URLEncoder.encode(ca_hostname, "UTF-8") +
                             "&caPort=" + ca_admin_port +
                             "&op=next" +
                             "&xml=true";
@@ -685,7 +676,7 @@ public class ConfigureTPS {
         return true;
     }
 
-    public boolean ConfigureTPSInstance() {
+    public boolean ConfigureTPSInstance() throws UnsupportedEncodingException {
         // 0. login to cert db
         ComCrypto cCrypt = new ComCrypto(client_certdb_dir,
                                         client_certdb_pwd,
@@ -807,7 +798,7 @@ public class ConfigureTPS {
         return true;
     }
 
-    public static void main(String args[]) {
+    public static void main(String args[]) throws UnsupportedEncodingException {
         ConfigureTPS ca = new ConfigureTPS();
 
         // set variables
diff --git a/pki/dogtag/common-ui/shared/admin/console/config/databasepanel.vm b/pki/dogtag/common-ui/shared/admin/console/config/databasepanel.vm
index 36439b4e640ff3a01cfd1496f1e90b7298e1fe7c..ce04e4fbcf177a76e0be076150a27593953b93cc 100644
--- a/pki/dogtag/common-ui/shared/admin/console/config/databasepanel.vm
+++ b/pki/dogtag/common-ui/shared/admin/console/config/databasepanel.vm
@@ -43,7 +43,8 @@ function toggle_details()
 Each instance needs access to a Fedora Directory Server instance to store requests and records. Each PKI instance may create its own associated internal database, or may share an existing internal database. To share an existing internal database instance, a PKI instance would only need to establish a unique distinguished name (DN) using the field entitled <b>Base DN</b> and a unique database name using the field entitled <b>Database</b>. 
 #if ($clone == "clone")
 <p>
-If the replication between the masters and clones occurs on the non-SSL port, it is still possible to require the replication to be SSL encrypted by selecting <b> Use StartTLS with replication agreements</b> below.  In order for this operation to be successful, the database instances must be SSL enabled before continuing beyond this panel.
+<p>
+Replication agreements between the master and clone database instances may be customized.  If no master and replication ports are provided, then replication will occur on the same ports used by the Certificate Sever instances to communicate with the directory server.  If these ports are LDAPS ports, then the replication traffic will be SSL encrypted.  It is still possible to require the replication traffic to be SSL encrypted on the non-SSL port by selecting TLS for Replication Security.  In order for this operation to be successful though, the database instances must be SSL enabled before continuing beyond this panel.
 #end
 </div>
 <p>
@@ -64,8 +65,8 @@ If the replication between the masters and clones occurs on the non-SSL port, it
         <th>Port:</th>
                                 
         <td><input type="text" size="40" name="port" value="$portStr" />  
-<input type="CHECKBOX" NAME="secureConn">SSL
-</td>
+            <input type="CHECKBOX" NAME="secureConn">SSL
+        </td>
       </tr>       
       <tr>
         <th>Base DN:</th>
@@ -90,12 +91,32 @@ If the replication between the masters and clones occurs on the non-SSL port, it
         <td><input type="password" size="40" name="__bindpwd" value="$bindpwd" autocomplete="off" /></td>
       </tr>
     </table>
-        <input type="hidden" name="display" value=$displayStr />
- 
-#if ($clone == "clone") 
-      <input type="CHECKBOX" NAME="cloneStartTLS"/>Use StartTLS with replication agreements.<p>
-#end 
-<input type="CHECKBOX" NAME="removeData">Remove the existing data from the <b>Base DN</b> shown above.<p>
+    <input type="hidden" name="display" value=$displayStr />
+    <input type="CHECKBOX" NAME="removeData">Remove the existing data from the <b>Base DN</b> shown above.<p>
+    
+#if ($clone == "clone")
+    <table class="details" >
+      <tr><th>Replication Details</th></tr>
+      <tr>
+        <th>Master Replication Port:</th>
+        <td><input type="text" size="40" name="masterReplicationPort" value="$masterReplicationPort" /></td>
+      </tr>
+
+      <tr>
+        <th>Clone Replication Port:</th>
+        <td><input type="text" size="40" name="cloneReplicationPort" value="$cloneReplicationPort" /></td>
+      </tr>
+
+      <tr>
+        <th>Replication Security:</th>
+        <td>
+            <input type="radio" name="replicationSecurity" value="None" CHECKED />None</input>
+            <input type="radio" name="replicationSecurity" value="TLS"          />TLS</input>
+            <input type="radio" name="replicationSecurity" value="SSL"          />SSL</input>
+        </td>
+      </tr>
+      <p>
+#end
 
     <div align="right">
       <hr />
-- 
1.7.6.4

